Subject: Access to undefined index when an inheritance chain member is not an Entity
Description

It comes to an exception like this,

#1355480641: Uncaught Exception Notice: Undefined index: TYPO3\Media\Domain\Model\lmageVariant in
Packages\Framework\TYPO3.Flow\Classes\TYPO3\Flow\Reflection\ReflectionService.php line 1461

This is because of these lines,
1 protected function makeChildClassesAggregateRoot(\TYPO3\Flow\Reflection\ClassSchema $classSchema) {
2 foreach ($this->getAllISubClassNamesForClass($classSchema->getClassName()) as $childClassName) {
3 if ($this->classSchemata[$childClassName]->isAggregateRoot()) {
4 continue;

In the given case, the ImageVariant inheritance looks like the following:

Asset (@Entity)
- SizedAsset (@Entity)
- ImageVariant (NOT an @Entity!)

The above mentioned method searches in ->classSchemata for the ImageVariant, but as of convention, classSchemata is "Schemata
of all classes which can be persisted", so ImageVariant is not there of course, leading to the exception.

Associated revisions

Revision 4¢520789 - 2013-05-02 10:36 - Adrian Foder

[BUGFIX] ReflectionService works for non-Entity inheritance members

As soon as a class which is not an entity was present as an
ancestor of an Entity (with at least one Entity descendant in
between), there was an Undefined Index error because the
ReflectionService proceeded on the assumption that everything
was an Entity, hence present in the ->classSchemata array.

This adds an additional check for the actual presence of

such an array index and proofs this behavior with a
Functional Test Fixture.
Fixes: #47809
Releases: master, 2.0
Change-Id: 112118004e60e2230a7021a73251ea7c57d660d3b

Revision be7b184a - 2013-09-25 09:32 - Adrian Foder

[BUGFIX] ReflectionService works for non-Entity inheritance members

As soon as a class which is not an entity was present as an
ancestor of an Entity (with at least one Entity descendant in
between), there was an Undefined Index error because the
ReflectionService proceeded on the assumption that everything
was an Entity, hence present in the ->classSchemata array.

This adds an additional check for the actual presence of
such an array index and proofs this behavior with a

Functional Test Fixture.
Fixes: #47809

Releases: master, 2.0
Change-Id: 112118004e60e2230a7021a73251ea7c57d660d3b

History

#1 - 2013-05-02 10:24 - Adrian Foder
- Status changed from New to Accepted

#2 - 2013-05-02 10:36 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/20402

#3 - 2013-05-21 12:09 - Robert Lemke
- Priority changed from Must have to Should have
- Target version set to 2.0

#4 - 2013-08-14 15:35 - Karsten Dambekalns
- Target version changed from 2.0 to 2.0.1

#5 - 2013-09-25 09:32 - Gerrit Code Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.0rg/24033

#6 - 2014-07-11 20:19 - Adrian Foder
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

2015-08-04

2/3


https://review.typo3.org/20402
https://review.typo3.org/24033

Applied in changeset commit:4c5207896059e9a3e5d841ddb564f387c51cb634.
